# Dispatcher - Cache Rules

### Allow Authorized Example

[See Documentation](https://docs.adobe.com/docs/en/dispatcher/disp-config.html#Caching%20When%20Authentication%20is%20Used)

Custom Allow Authorized definition:

~~~
aem::dispatcher::farm { 'site' :
  docroot          => '/var/www',
  allow_authorized => 1,
}
~~~

This definition will create a file *dispatcher.site.any* with the following contents:

~~~
/anothersite {

  /clientheaders {
    "*"
  }

  /virtualhosts {
    "*"
  }

  /renders {
    /renderer0 {
      /hostname "localhost"
      /port "4503"
    }
  }

  /filter {
    /0 { /type "allow" /glob "*" }
  }

  /cache {

    /docroot "/var/www"

    /allowAuthorized "1"

    /rules {
      /0 { /type "deny" /glob "*" }
    }

    /invalidate {
      /0 { /type "allow" /glob "*" }
    }

    /allowedClients {
      /0 { /type "allow" /glob "*" }
    }
  }
}
~~~