# == Define: aem::agent::replication::publish
#
# Configure a Publish Replication Agent
define aem::agent::replication::publish(
  $agent_user           = undef,
  $description          = undef,
  $enabled              = true,
  $ensure               = 'present',
  $force_passwords      = undef,
  $home                 = undef,
  $log_level            = undef,
  $password             = undef,
  $runmode              = undef,
  $timeout              = undef,
  $trans_allow_exp_cert = undef,
  $trans_password       = undef,
  $trans_ssl            = undef,
  $trans_uri            = undef,
  $trans_user           = undef,
  $trigger_ignore_def   = undef,
  $trigger_no_status    = undef,
  $trigger_no_version   = undef,
  $trigger_on_dist      = undef,
  $trigger_on_mod       = undef,
  $trigger_on_receive   = undef,
  $trigger_onoff_time   = undef,
  $username             = undef
) {
  aem::agent::replication { $title :
    ensure               => $ensure,
    agent_user           => $agent_user,
    description          => $description,
    enabled              => $enabled,
    force_passwords      => $force_passwords,
    home                 => $home,
    log_level            => $log_level,
    name                 => $name,
    password             => $password,
    resource_type        => 'cq/replication/components/agent',
    runmode              => $runmode,
    serialize_type       => 'durbo',
    template             => '/libs/cq/replication/templates/agent',
    timeout              => $timeout,
    trans_allow_exp_cert => $trans_allow_exp_cert,
    trans_password       => $trans_password,
    trans_ssl            => $trans_ssl,
    trans_uri            => $trans_uri,
    trans_user           => $trans_user,
    trigger_ignore_def   => $trigger_ignore_def,
    trigger_no_status    => $trigger_no_status,
    trigger_no_version   => $trigger_no_version,
    trigger_on_dist      => $trigger_on_dist,
    trigger_on_mod       => $trigger_on_mod,
    trigger_on_receive   => $trigger_on_receive,
    trigger_onoff_time   => $trigger_onoff_time,
    username             => $username
  }
}
